module misc.Location;

import misc.DataSource;

import tango.text.convert.Integer,
       tango.text.Util;

struct Location
{
    uint position;
    DataSource source;

    char[] toString ()
    {
        int lineNumber = 0;
        char[] end_line;
        foreach (line; lines(source.get(0, position)))
        {
            ++lineNumber;
            end_line = line;
        }
        return source.name
            ~ "(" ~ .toString(lineNumber)
            ~ ":" ~ .toString(end_line.length) ~ ")";
    }

    char[] get(uint length)
    {
        return source.get(position, length);
    }
}
